Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java	(revision 43114)
@@ -10,6 +10,7 @@
 import org.apache.commons.lang3.StringUtils;
 import org.apache.commons.lang3.tuple.ImmutablePair;
 import org.apache.commons.lang3.tuple.Pair;
+import org.cresques.cts.IProjection;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.ExpressionBuilder;
 import org.gvsig.fmap.dal.SQLBuilder;
@@ -30,6 +31,10 @@
 import org.gvsig.fmap.dal.SQLBuilder.UpdateBuilder;
 import org.gvsig.fmap.dal.SQLBuilder.UpdateColumnBuilder;
 import org.gvsig.fmap.dal.SQLBuilder.UpdateTableStatisticsBuilder;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.GeometryManager;
+import org.gvsig.fmap.geom.type.GeometryType;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
@@ -48,39 +53,178 @@
     protected UpdateTableStatisticsBuilder update_table_statistics;
     protected List<Parameter> parameters;
 
-    protected class ColumnInfo {
+    protected class ColumnDescriptorBuilderBase implements ColumnDescriptorBuilder {
 
-        public String name;
-        public int type;
-        public int type_p;
-        public int type_s;
-        public boolean isPk;
-        public boolean allowNulls;
-        public boolean isAutomatic;
-        public Object defaultValue;
+        private String name;
+        private int type;
+        private int type_p;
+        private int type_s;
+        private boolean isPk;
+        private boolean _allowNulls;
+        private boolean _isAutomatic;
+        private Object defaultValue;
+        private int geom_type;
+        private int geom_subtype;
+        private int geom_srsid;
 
-        public ColumnInfo(String name, int type, Object defaultValue) {
+        public ColumnDescriptorBuilderBase(String name, int type, Object defaultValue) {
             this.name = name;
             this.type = type;
             this.type_p = -1;
             this.type_s = -1;
             this.isPk = false;
-            this.allowNulls = true;
-            this.isAutomatic = false;
+            this._allowNulls = true;
+            this._isAutomatic = false;
             this.defaultValue = defaultValue;
+            this.geom_type = Geometry.TYPES.GEOMETRY;
+            this.geom_subtype = Geometry.SUBTYPES.GEOM2D;
+            this.geom_srsid = -1;
         }
 
-        public ColumnInfo(String name, int type, int type_p, int type_s, boolean isPk, boolean allowNulls, boolean isAutomatic, Object defaultValue) {
+        public ColumnDescriptorBuilderBase(String name, int type, int type_p, int type_s, boolean isPk, boolean allowNulls, boolean isAutomatic, Object defaultValue) {
             this.name = name;
             this.type = type;
             this.type_p = type_p;
             this.type_s = type_s;
             this.isPk = isPk;
-            this.allowNulls = allowNulls;
-            this.isAutomatic = isAutomatic;
+            this._allowNulls = allowNulls;
+            this._isAutomatic = isAutomatic;
             this.defaultValue = defaultValue;
+            this.geom_type = Geometry.TYPES.GEOMETRY;
+            this.geom_subtype = Geometry.SUBTYPES.GEOM2D;
+            this.geom_srsid = -1;
         }
+        
+        public ColumnDescriptorBuilderBase(String name, int geom_type, int geom_subtype, IProjection proj, boolean allowNulls) {
+            this.name = name;
+            this.type_p = 0;
+            this.type_s = 0;
+            this.isPk = false;
+            this._allowNulls = allowNulls;
+            this._isAutomatic = false;
+            this.defaultValue = null;
+            this.geom_type = geom_type;
+            this.geom_subtype = geom_subtype;
+            this.geom_srsid = getSRSId(proj);
+        }
+        
+        @Override
+        public String getName() {
+            return this.name;
+        }
+        
+        @Override
+        public void setName(String name) {
+            this.name = name;
+        }
+
+        @Override
+        public int getType() {
+            return this.type;
+        }
+
+        @Override
+        public void setType(int type) {
+            this.type = type;
+        }
+
+        @Override
+        public int getPrecision() {
+            return type_p;
+        }
+
+        @Override
+        public void setPrecision(int precision) {
+            this.type_p = precision;
+        }
+
+        @Override
+        public int getSize() {
+            return type_s;
+        }
+
+        @Override
+        public void setSize(int size) {
+            this.type_s = size;
+        }
+
+        @Override
+        public boolean isPrimaryKey() {
+            return isPk;
+        }
+
+        @Override
+        public void setIsPrimaryKey(boolean isPk) {
+            this.isPk = isPk;
+        }
+
+        @Override
+        public boolean allowNulls() {
+            return _allowNulls;
+        }
+
+        @Override
+        public void setAllowNulls(boolean allowNulls) {
+            this._allowNulls = allowNulls;
+        }
+
+        @Override
+        public boolean isAutomatic() {
+            return _isAutomatic;
+        }
+
+        @Override
+        public void setIsAutomatic(boolean isAutomatic) {
+            this._isAutomatic = isAutomatic;
+        }
+
+        @Override
+        public Object getDefaultValue() {
+            return defaultValue;
+        }
+
+        @Override
+        public void setDefaultValue(Object defaultValue) {
+            this.defaultValue = defaultValue;
+        }
+
+        @Override
+        public int getGeometryType() {
+            return geom_type;
+        }
+
+        @Override
+        public void setGeometryType(int geom_type) {
+            this.geom_type = geom_type;
+        }
+
+        @Override
+        public int getGeometrySubtype() {
+            return geom_subtype;
+        }
+
+        @Override
+        public void setGeometrySubtype(int geom_subtype) {
+            this.geom_subtype = geom_subtype;
+        }
+
+        @Override
+        public int getGeometrySRSId() {
+            return geom_srsid;
+        }
+
+        @Override
+        public void setGeometrySRSId(int geom_srsid) {
+            this.geom_srsid = geom_srsid;
+        }        
+
+        @Override
+        public boolean isGeometry() {
+            return this.type == DataTypes.GEOMETRY;
+        }
+                
     }
+    
 
     public class TableNameBuilderBase implements TableNameBuilder {
 
@@ -222,7 +366,7 @@
         @Override
         public TableNameBuilder table() {
             if( tableName == null ) {
-                this.tableName = new TableNameBuilderBase();
+                this.tableName = createTableNameBuilder();
             }
             return this.tableName;
         }
@@ -363,7 +507,7 @@
         protected boolean ascending;
         
         public OrderByBuilderBase() {
-            
+            this.ascending = true;
         }
 
         @Override
@@ -620,7 +764,7 @@
         @Override
         public TableNameBuilder table() {
             if( table == null ) {
-                table = new TableNameBuilderBase();
+                table = createTableNameBuilder();
             }
             return table;
         }
@@ -804,7 +948,7 @@
         @Override
         public TableNameBuilder table() {
             if( table == null ) {
-                table = new TableNameBuilderBase();
+                table = createTableNameBuilder();
             }
             return table;
         }
@@ -912,7 +1056,7 @@
         @Override
         public TableNameBuilder table() {
             if( table == null ) {
-                table = new TableNameBuilderBase();
+                table = createTableNameBuilder();
             }
             return table;
         }
@@ -1002,7 +1146,7 @@
         @Override
         public TableNameBuilder table() {
             if( table == null ) {
-                table = new TableNameBuilderBase();
+                table = createTableNameBuilder();
             }
             return table;
         }
@@ -1039,8 +1183,8 @@
 
         protected TableNameBuilder table;
         protected List<String> drops;
-        protected List<ColumnInfo> adds;
-        protected List<ColumnInfo> alters;
+        protected List<ColumnDescriptorBuilderBase> adds;
+        protected List<ColumnDescriptorBuilderBase> alters;
         protected List<Pair> renames;
 
         public AlterTableBuilderBase() {
@@ -1063,7 +1207,7 @@
         @Override
         public TableNameBuilder table() {
             if( table == null ) {
-                table = new TableNameBuilderBase();
+                table = createTableNameBuilder();
             }
             return table;
         }
@@ -1079,7 +1223,7 @@
             if (isPk || isAutomatic) {
                 allowNulls = false;
             }
-            this.adds.add(new ColumnInfo(columnName, type, type_p, type_s, isPk, allowNulls, isAutomatic, defaultValue));
+            this.adds.add(new ColumnDescriptorBuilderBase(columnName, type, type_p, type_s, isPk, allowNulls, isAutomatic, defaultValue));
             return this;
         }
 
@@ -1088,7 +1232,7 @@
             if (isPk || isAutomatic) {
                 allowNulls = false;
             }
-            this.alters.add(new ColumnInfo(columnName, type, type_p, type_s, isPk, allowNulls, isAutomatic, defaultValue));
+            this.alters.add(new ColumnDescriptorBuilderBase(columnName, type, type_p, type_s, isPk, allowNulls, isAutomatic, defaultValue));
             return this;
         }
 
@@ -1189,69 +1333,69 @@
                 builder.append(column);
             }
             first = drops.isEmpty();
-            for (ColumnInfo column : adds) {
+            for (ColumnDescriptorBuilderBase column : adds) {
                 if (first) {
                     first = false;
                 } else {
                     builder.append(", ");
                 }
                 builder.append("ADD COLUMN ");
-                builder.append(column.name);
+                builder.append(column.getName());
                 builder.append(" ");
-                if( column.type == DataTypes.INT && column.isAutomatic ) {
+                if( column.getType() == DataTypes.INT && column.isAutomatic() ) {
                     builder.append(" SERIAL");
                 } else {
-                    builder.append(sqltype(column.type, column.type_p, column.type_s));
+                    builder.append(sqltype(column.getType(), column.getPrecision(), column.getSize()));
                 }
-                if (column.defaultValue == null) {
-                    if (column.allowNulls) {
+                if (column.getDefaultValue() == null) {
+                    if (column.allowNulls()) {
                         builder.append(" DEFAULT NULL");
                     }
                 } else {
                     builder.append(" DEFAULT '");
-                    builder.append(column.defaultValue.toString());
+                    builder.append(column.getDefaultValue().toString());
                     builder.append("'");
                 }
-                if (column.allowNulls) {
+                if (column.allowNulls()) {
                     builder.append(" NULL");
                 } else {
                     builder.append(" NOT NULL");
                 }
-                if (column.isPk) {
+                if (column.isPrimaryKey()) {
                     builder.append(" PRIMARY KEY");
                 }
             }
             first = drops.isEmpty() && adds.isEmpty();
-            for (ColumnInfo column : alters) {
+            for (ColumnDescriptorBuilderBase column : alters) {
                 if (first) {
                     first = false;
                 } else {
                     builder.append(", ");
                 }
                 builder.append("ALTER COLUMN ");
-                builder.append(column.name);
+                builder.append(column.getName());
                 builder.append("SET DATA TYPE ");
-                if( column.type == DataTypes.INT && column.isAutomatic ) {
+                if( column.getType() == DataTypes.INT && column.isAutomatic() ) {
                     builder.append(" SERIAL");
                 } else {
-                    builder.append(sqltype(column.type, column.type_p, column.type_s));
+                    builder.append(sqltype(column.getType(), column.getPrecision(), column.getSize()));
                 }
                 builder.append(", ");
-                if (column.defaultValue == null) {
-                    if (column.allowNulls) {
+                if (column.getDefaultValue() == null) {
+                    if (column.allowNulls()) {
                         builder.append("ALTER COLUMN ");
-                        builder.append(column.name);
+                        builder.append(column.getName());
                         builder.append(" SET DEFAULT NULL");
                     } else {
                         builder.append("ALTER COLUMN ");
-                        builder.append(column.name);
+                        builder.append(column.getName());
                         builder.append(" DROP DEFAULT");
                     }
                 } else {
                     builder.append("ALTER COLUMN ");
-                    builder.append(column.name);
+                    builder.append(column.getName());
                     builder.append(" SET DEFAULT '");
-                    builder.append(column.defaultValue.toString());
+                    builder.append(column.getDefaultValue().toString());
                     builder.append("'");
                 }
             }
@@ -1277,7 +1421,7 @@
     public class CreateTableBuilderBase implements CreateTableBuilder {
 
         protected TableNameBuilder table;
-        protected List<ColumnInfo> columns;
+        protected List<ColumnDescriptorBuilderBase> columns;
 
         public CreateTableBuilderBase() {
             this.columns = new ArrayList<>();
@@ -1296,21 +1440,46 @@
         @Override
         public TableNameBuilder table() {
             if( table == null ) {
-                table = new TableNameBuilderBase();
+                table = createTableNameBuilder();
             }
             return table;
         }
 
         @Override
         public CreateTableBuilderBase add_column(String columnName, int type, int type_p, int type_s, boolean isPk, boolean allowNulls, boolean isAutomatic, Object defaultValue) {
+            if( StringUtils.isEmpty(columnName) ) {
+                throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
+            }
             if (isPk || isAutomatic) {
                 allowNulls = false;
             }
-            this.columns.add(new ColumnInfo(columnName, type, type_p, type_s, isPk, allowNulls, isAutomatic, defaultValue));
+            this.columns.add(new ColumnDescriptorBuilderBase(columnName, type, type_p, type_s, isPk, allowNulls, isAutomatic, defaultValue));
             return this;
         }
 
         @Override
+        public CreateTableBuilder add_geometry_column(String columnName, int type, int subtype, IProjection proj, boolean allowNulls) {
+            if( StringUtils.isEmpty(columnName) ) {
+                throw new IllegalArgumentException("Argument 'columnName' can't be empty.");
+            }
+            this.columns.add(new ColumnDescriptorBuilderBase(columnName, type, subtype, proj, allowNulls));
+            return this;
+        }
+
+        @Override
+        public ColumnDescriptorBuilder getColumnDescriptor(String columnName) {
+            if( StringUtils.isEmpty(columnName) ) {
+                return null;
+            }
+            for (ColumnDescriptorBuilderBase column : columns) {
+                if( columnName.equals(column.getName()) ) {
+                    return column;
+                }
+            }
+            return null;
+        }
+                
+        @Override
         public String toString() {
             StringBuilder builder = new StringBuilder();
             boolean first = true;
@@ -1362,36 +1531,36 @@
             builder.append(this.table.toString());
             builder.append(" (");
             boolean first = true;
-            for (ColumnInfo column : columns) {
+            for (ColumnDescriptorBuilderBase column : columns) {
                 if (first) {
                     first = false;
                 } else {
                     builder.append(", ");
                 }
-                builder.append(identifier(column.name));
+                builder.append(identifier(column.getName()));
                 builder.append(" ");
-                if( column.isAutomatic && column.type == DataTypes.INT ) {
+                if( column.isAutomatic() && column.getType() == DataTypes.INT ) {
                     builder.append("SERIAL");
-                } else if( column.isAutomatic && column.type == DataTypes.LONG ) {
+                } else if( column.isAutomatic() && column.getType() == DataTypes.LONG ) {
                     builder.append("BIGSERIAL");
                 } else {
-                    builder.append(sqltype(column.type, column.type_p, column.type_s));
+                    builder.append(sqltype(column.getType(), column.getPrecision(), column.getSize()));
                 }
-                if (column.defaultValue == null) {
-                    if (column.allowNulls) {
+                if (column.getDefaultValue() == null) {
+                    if (column.allowNulls()) {
                         builder.append(" DEFAULT NULL");
                     }
                 } else {
                     builder.append(" DEFAULT '");
-                    builder.append(column.defaultValue.toString());
+                    builder.append(column.getDefaultValue().toString());
                     builder.append("'");
                 }
-                if (column.allowNulls) {
+                if (column.allowNulls()) {
                     builder.append(" NULL");
                 } else {
                     builder.append(" NOT NULL");
                 }
-                if (column.isPk) {
+                if (column.isPrimaryKey()) {
                     builder.append(" PRIMARY KEY");
                 }
             }
@@ -1475,7 +1644,7 @@
         @Override
         public TableNameBuilder table() {
             if( table == null ) {
-                table = new TableNameBuilderBase();
+                table = createTableNameBuilder();
             }
             return table;
         }
@@ -1544,7 +1713,7 @@
         @Override
         public TableNameBuilder table() {
             if( table == null ) {
-                table = new TableNameBuilderBase();
+                table = createTableNameBuilder();
             }
             return table;
         }
@@ -1704,6 +1873,75 @@
         }
     }
 
+    private static Map<Pair<Integer,Integer>,String> sqlgeometrytypes = null;
+    
+    @Override
+    public Object sqlgeometrytype(int type, int subtype) {
+        // Devuelve un Object por que algunos gestores de BBDD utilizan
+        // identificadores numericos para el tipo y otros strings.
+        // Por defecto vamos a devolver strings.
+        if( sqlgeometrytypes==null ) {
+            sqlgeometrytypes = new HashMap<>();
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM2D), "POINT");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM3D), "POINTZ");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM2DM), "POINTM");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POINT,Geometry.SUBTYPES.GEOM3DM), "POINTZM");
+
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM2D), "LINESTRING");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM3D), "LINESTRINGZ");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM2DM), "LINESTRINGM");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.LINE,Geometry.SUBTYPES.GEOM3DM), "LINESTRINGZM");
+
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM2D), "POLYGON");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM3D), "POLYGONZ");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM2DM), "POLYGONM");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.POLYGON,Geometry.SUBTYPES.GEOM3DM), "POLYGONZM");
+
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM2D), "MULTIPOINT");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM3D), "MULTIPOINTZ");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM2DM), "MULTIPOINTM");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOINT,Geometry.SUBTYPES.GEOM3DM), "MULTIPOINTZM");
+
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM2D), "MULTILINESTRING");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM3D), "MULTILINESTRINGZ");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM2DM), "MULTILINESTRINGM");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTILINE,Geometry.SUBTYPES.GEOM3DM), "MULTILINESTRINGZM");
+
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM2D), "MULTIPOLYGON");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM3D), "MULTIPOLYGONZ");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM2DM), "MULTIPOLYGONM");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.MULTIPOLYGON,Geometry.SUBTYPES.GEOM3DM), "MULTIPOLYGONZM");
+
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM2D), "GEOMETRY");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM3D), "GEOMETRYZ");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM2DM), "GEOMETRYM");
+            sqlgeometrytypes.put( new ImmutablePair<>(Geometry.TYPES.GEOMETRY,Geometry.SUBTYPES.GEOM3DM), "GEOMETRYZM");
+        }
+        return sqlgeometrytypes.get(new ImmutablePair<>(type,subtype));
+    }
+
+    @Override
+    public Object sqlgeometrydimension(int type, int subtype) {
+        // Devuelve un Object por que algunos gestortes de BBDD utilizan
+        // identificadores numericos para las dimensiones y otros strings.
+        // Por defecto vamos a devolver enteros.
+        switch(subtype) {
+            case Geometry.SUBTYPES.GEOM3D:
+                return 3;
+            case Geometry.SUBTYPES.GEOM2DM:
+                return 3;
+            case Geometry.SUBTYPES.GEOM3DM:
+                return 4;
+            case Geometry.SUBTYPES.GEOM2D:
+            default:
+                return 2;
+        }
+    }
+    
+    protected TableNameBuilder createTableNameBuilder() {
+        return new TableNameBuilderBase();
+    }
+    
     protected SelectColumnBuilder createSelectColumnBuilder() {
         return new SelectColumnBuilderBase();
     }
